use std::collections::HashSet;

use crate::grammar::Grammar;
use crate::lr0item::Lr0Item;

pub struct CanonicalCollection<'g> {
    pub grammar: &'g Grammar,
    pub sets: HashSet<HashSet<Lr0Item>>,
}

impl<'g> CanonicalCollection<'g> {
    pub fn new(grammar: &'g Grammar) -> Self {
        CanonicalCollection {
            grammar,
            sets: HashSet::default(),
        }
    }

    pub fn clear(&mut self) {
        self.sets.clear();
    }

    pub fn build(&mut self) {
        self.clear();

        // add the start items
    }

    pub fn run(&self, input: &[u8]) {

    }
}
